<template>
    <!-- Message Button -->
    <q-btn
        no-caps
        class="btn btn-xs btn-light q-ml-md message"
        @click="message()"
    >
        Message
    </q-btn>

    <!-- Create Conversation Form -->
    <q-dialog v-model="state.createConversationForm" persistent>
        <q-card style="min-width: 500px">
            <q-card-section>
                <div class="text-h6">Create Conversation</div>
            </q-card-section>

            <q-card-section class="q-pt-none">
                <!-- Issue Type -->
                <p class="font-14 q-my-md helvetica-neue-medium">
                    {{ $t('tables.issueType') }}
                    <span class="text-ff0000 font-10" v-if="!state.issueType">
                        {{ $t('form.required') }}
                    </span>
                </p>

                <q-select
                    filled
                    v-model="state.issueType"
                    use-input
                    :options="state.issueTypeOption"
                    input-debounce="500"
                    clearable
                    option-value="id"
                    option-label="name"
                >
                    <template v-slot:no-option>
                        <q-item>
                            <q-item-section class="text-grey">
                                No results
                            </q-item-section>
                        </q-item>
                    </template>
                </q-select>

                <!-- Message -->
                <p class="font-14 q-my-md helvetica-neue-medium">
                    {{ $t('tables.message') }}
                    <span class="text-ff0000 font-10" v-if="!state.description">
                        {{ $t('form.required') }}
                    </span>
                </p>

                <q-input
                    outlined
                    :dense="dense"
                    v-model="state.description"
                    class="border-radius-20"
                ></q-input>
            </q-card-section>

            <q-card-actions align="right" class="text-primary">
                <q-btn flat label="Cancel" v-close-popup />
                <q-btn
                    flat
                    label="Create"
                    v-close-popup
                    @click="createConversation"
                />
            </q-card-actions>
        </q-card>
    </q-dialog>
</template>

<script lang="ts">
import { defineComponent, reactive, ref } from 'vue';
import { useStore } from 'src/store';
import { useRouter } from 'vue-router';
import { ConversationStatus } from 'src/services/enums/ConversationStatus';
import generateRandomString from 'src/services/helpers/GenerateRandomString';

export default defineComponent({
    name: 'MessageButtonTransferButton',
    props: {
        conversation: {
            type: Object,
            required: true
        },
        clientId: {
            type: String,
            required: true
        }
    },
    setup(props) {
        const store = useStore();
        const router = useRouter();

        let state = reactive({
            createConversationForm: ref(false),
            issueType: '' as any,
            issueTypeOption: [] as any,
            description: '' as any,
            clientID: '' as any
        });

        const message = async () => {
            state.issueTypeOption = store.state.issueType.issueTypes;
            let conversation = props.conversation;

            if (conversation.status == ConversationStatus.NEW) {
                // Condition 3 (No agent && No Conversation)
                // Create, Join, Show Conversation
                state.createConversationForm = true;
                state.clientID = props.clientId;
            } else {
                conversation = await getOneConversation(conversation);

                const conversationStatus = conversation.status;
                if (
                    conversation.agent != null ||
                    conversation.lastAgent != null
                ) {
                    const conversationAgentID = conversation.lastAgent
                        ? conversation.lastAgent.id
                        : conversation.agent.id;

                    const currentLoggedInAgent = store.state.user.user?.id;
                    const isOwner = conversationAgentID == currentLoggedInAgent;

                    if (isOwner) {
                        // Condition 1 (Current agent && Conversation active)
                        // Show conversation
                        if (
                            conversationStatus == 'Active' ||
                            conversationStatus == ConversationStatus.ACTIVE
                        ) {
                            goOnGoingPage(conversation);
                        }
                    }
                }

                // Condition 2 (Current agent && Conversation closed)
                // Reactivate , Join, Show Conversation
                if (
                    conversationStatus == 'Closed' ||
                    conversationStatus == ConversationStatus.CLOSED
                ) {
                    const result = await store.dispatch(
                        'conversation/messageClient',
                        conversation.id
                    );

                    goOnGoingPage(result.conversations[0]);
                }
            }
        };

        const getOneConversation = async (conversation: any) => {
            if (conversation) {
                const result = await store.dispatch(
                    'conversation/getOneConversation',
                    {
                        conversationId: conversation.id,
                        isDownward: 0
                    }
                );

                return result.conversations[0];
            }
        };

        const goOnGoingPage = (conversation: any) => {
            router.push({
                path: '/chat',
                query: {
                    conversationId: conversation.id,
                    businessId: store.state.business.businessID,
                    branchId: store.state.branch.branch.id
                }
            });
            store.dispatch('menu/setSelectedShortcut', 'ongoing');
            store.dispatch('conversation/setTicketConversation', conversation);
        };

        const createConversation = async () => {
            const body = {
                issueTypeId: state.issueType.id,
                description: state.description,
                localId: generateRandomString(24),
                userId: state.clientID
            };

            const response = await store.dispatch(
                'conversation/createConversation',
                body
            );

            goOnGoingPage(response.data.result.conversation);
        };

        return {
            message,
            state,
            createConversation
        };
    }
});
</script>
